# Description
This repository contains several libraries intended for the STM32 micro-
processors. 

This repository also includes implementations of several communication 
peripherals compatible with the Comm library for several families of the STM32
micro-processors.

This libraries include:

## Utils
An implementation of a simple circular buffer and a placeholder to handle time
functions using a hardware timer.

## Memory
A set of data structures that simplifies the managment of the memory space of a 
Dynamixel slave. It allows to allocate a specific ammount of memory either in 
RAM or EPPOM, and also at a pre-defined position or anywhere in the available 
memory space.

It also provides user defined read and write callback functions to further 
simplify read and write operations started from the bus master.

## Comm
A generic communication device which allows working either in blocking mode, in
interrupt mode or DMA mode with almost any communcation peripheral in the STM32. 

It provides a set of user defined callback functions, both on the low level 
peripheral side and also in the high level application side, which simplifies 
handling the communciation channel. 

## Dynamixel base
This library implements the whole Dynamixel protocol, both version 1 and 2, and
also as a master and as a slave. This implementation is idependant of the 
communication channel because it uses the comm library.

All the operations of both supported versions are available.

## Dynamixel manager
An experimental library designed to simplify the bus access to the shared 
Dynamixel bus by several heterogeneous modules. This library allows to configure 
the necessary transactions (READ, WRITE, SYNC_READ, SYNC_WRITE, BULK_READ or
BULK_WRITE) on several dynamixel buses. 

Additionally, each transaction can be configured as periodic or one shot.


# Dependencies


