#ifndef _ACTION_H
#define _ACTION_H

#ifdef __cplusplus
extern "C" {
#endif

#include "motion_pages.h"
#include "motion_module.h"
#include "motion_pages.h"
#include "memory.h"

typedef enum {ACTION_PRE,ACTION_MAIN,ACTION_POST,ACTION_PAUSE} action_states;

typedef struct{
  TMotionModule mmodule;
  TMemory *memory;
  TMemModule mem_module;
  unsigned short int ram_base_address;
  unsigned short int eeprom_base_address;  
  TPage next_page;
  TPage current_page;
  unsigned char current_step_index;
  unsigned char current_page_index;
  // angle variables
  long long int moving_angles[PAGE_MAX_NUM_SERVOS];// fixed point 48|16 format
  long long int start_angles[PAGE_MAX_NUM_SERVOS];// fixed point 48|16 format
  // speed variables
  long long int start_speed[PAGE_MAX_NUM_SERVOS];// fixed point 48|16 format
  long long int main_speed[PAGE_MAX_NUM_SERVOS];// fixed point 48|16 format
  // control variables
  unsigned char end;
  unsigned char stop;
  unsigned char zero_speed_finish[PAGE_MAX_NUM_SERVOS];
  unsigned char next_index;
  unsigned char running;
  // time variables (in time units (7.8 ms each time unit))
  long long int total_time;// fixed point 48|16 format
  long long int pre_time;// fixed point 48|16 format
  long long int main_time;// fixed point 48|16 format
  long long int step_time;// fixed point 48|16 format
  long long int pause_time;// fixed point 48|16 format
  long long int current_time;// fixed point 48|16 format
  long long int section_time;// fixed point 48|16 format
  long long int period;
  // angle variables 
  long long int accel_angles[PAGE_MAX_NUM_SERVOS];// fixed point 48|16 format
  long long int main_angles[PAGE_MAX_NUM_SERVOS];// fixed point 48|16 format
  // speed variables (in controller units)
  long long int current_speed[PAGE_MAX_NUM_SERVOS];// fixed point 48|16 format
  long long int delta_speed;
  char num_repetitions;
  // control variables 
  action_states state;
}TActionMModule;

// public functions
unsigned char action_init(TActionMModule *action,TMemory *memory,unsigned short int ram_base_address);
TMotionModule *action_get_module(TActionMModule *action);
unsigned char action_load_page(TActionMModule *action,unsigned char page_id);
void action_start_page(TActionMModule *action);
void action_stop_page(TActionMModule *action);
unsigned char action_is_running(TActionMModule *action);
unsigned char action_get_current_page(TActionMModule *action);
unsigned char action_get_current_step(TActionMModule *action);

#ifdef __cplusplus
}
#endif

#endif
