#include "motion_pages.h"

void pages_get_page(unsigned char page_id,TPage *page)
{
  unsigned short int i=0;

  for(i=0;i<sizeof(TPage);i++)
    ((unsigned char *)page)[i]=((unsigned char *)&motion_pages[page_id])[i];
}

unsigned char pages_check_checksum(TPage *page)
{
  unsigned char checksum=0x00;
  unsigned short int i=0;

  for(i=0;i<sizeof(TPage);i++)
    checksum+=((unsigned char *)page)[i];
  if(checksum==0x00)
    return 0x01;
  else
    return 0x00;
}

void pages_clear_page(TPage *page)
{
  unsigned short int i=0;

  for(i=0;i<sizeof(TPage);i++)
    ((unsigned char *)page)[i]=0x00;
}

void pages_copy_page(TPage *src,TPage *dst)
{
  unsigned short int i=0;

  for(i=0;i<sizeof(TPage);i++)
    ((unsigned char *)dst)[i]=((unsigned char *)src)[i];
}

inline unsigned char pages_get_slope(TPage *page,unsigned char servo_id)
{
  return 0x01<<(page->header.slope[servo_id]&0x0F);
}

TPage motion_pages[MAX_PAGES] __attribute__ ((section (".pages"))) __attribute__((weak)) ;
