#ifndef USB_F3_H
#define USB_F3_H

#include "stm32f3xx_hal.h"
#include "comm.h"
#include "usbd_def.h"

/* public functions */
void usb_init(TComm *comm_dev,USBD_DescriptorsTypeDef *pdesc,USBD_ClassTypeDef *pclass);
void usb_disconnect(void);
void usb_connect(void);
/* IRQ functions */
unsigned char usb_send_irq(unsigned char first_byte);
unsigned char usb_enable_tx_irq(void);
unsigned char usb_receive_irq(void);
unsigned char usb_cancel_receive_irq(void);
/* DMA functions */
unsigned char usb_send_dma(unsigned char *data,unsigned short int length);
unsigned char usb_receive_dma(unsigned char *data,unsigned short int length);
unsigned char usb_cancel_receive_dma(void);

#endif
