#ifndef USART4_F4_H
#define USART4_F4_H

#include "stm32f4xx_hal.h"
#include "usart_common.h"
#include "comm.h"

/* public functions */
void usart4_init(TComm *comm_dev,UART_InitTypeDef *conf,TUSART_IRQ_Priorities *priorities);
void usart4_config(TComm *comm_dev,UART_InitTypeDef *conf);
void usart4_set_priorities(TComm *comm_dev,TUSART_IRQ_Priorities *priorities);
void usart4_set_baudrate(TComm *comm_dev,unsigned int baudrate);
/* IRQ functions */
unsigned char usart4_send_irq(unsigned char first_byte);
unsigned char usart4_enable_tx_irq(void);
unsigned char usart4_receive_irq(void);
unsigned char usart4_cancel_receive_irq(void);
/* DMA functions */
unsigned char usart4_send_dma(unsigned char *data,unsigned short int length);
unsigned char usart4_receive_dma(unsigned char *data,unsigned short int length);
unsigned char usart4_cancel_receive_dma(void);

#endif
