#ifndef _FRAME_BUFFER_H
#define _FRAME_BUFFER_H

#ifdef __cplusplus
extern "C" {
#endif

#include "memory.h"

#ifndef FB_MAX_BUFFER_LEN
  #error "Please, specify the maximum frame buffer length with the FB_MAX_BUFFER_LEN macro"
#endif

#define FB_BYTES_PER_PIXEL     3

typedef struct
{
  TMemory *memory;
  unsigned short int ram_base_address;
  unsigned short int eeprom_base_address;
  unsigned short int num_rows;
  unsigned short int num_pixels_per_row;
  unsigned short int num_buffers;
  unsigned short int buffer_size;
  unsigned short int free_mem;
  unsigned char pixel_buffer[FB_MAX_BUFFER_LEN];
}TFrameBuffer;

void frame_buffer_init(TFrameBuffer *fb,TMemory *memory,unsigned short int ram_base_address,unsigned short int eeprom_base_address);
void frame_buffer_set_num_rows(TFrameBuffer *fb,unsigned short int rows);
unsigned short int frame_buffer_get_num_rows(TFrameBuffer *fb);
void frame_buffer_set_pixels_per_row(TFrameBuffer *fb,unsigned short int pixels);
unsigned short int frame_buffer_get_pixels_per_row(TFrameBuffer *fb);
void frame_buffer_set_num_buffers(TFrameBuffer *fb,unsigned char num);
unsigned char frame_buffer_get_num_buffers(TFrameBuffer *fb);
unsigned short int frame_buffer_get_free_memory(TFrameBuffer *fb);
unsigned char *frame_buffer_get_buffer(TFrameBuffer *fb,unsigned char buffer_id);
void frame_buffer_set_pixel(TFrameBuffer *fb,unsigned char buffer_id,unsigned char R,unsigned char G,unsigned char B,unsigned short int row,unsigned short int col);

#ifdef __cplusplus
}
#endif


#endif
