#ifndef _FRAME_BUFFER_CONTROL_REGISTERS_H
#define _FRAME_BUFFER_CONTROL_REGISTERS_H

#define RAM_FRAME_BUFFER_CONTROL_LENGTH                       (18+FBC_MAX_DATA_PATTERN_LEN+IMG_MAX_NUM_IMAGES*IMG_MAX_IMAGE_WIDTH*IMG_MAX_IMAGE_HEIGHT*3)

#define FRAME_BUFFER_CONTROL_NUM_PATTERN_OFFSET               0
#define FRAME_BUFFER_CONTROL_PATTERN_INDEX_OFFSET             1
#define FRAME_BUFFER_CONTROL_OFFSET                           2
#define FRAME_BUFFER_CONTROL_PATTERN_ID_OFFSET                3
#define FRAME_BUFFER_CONTROL_MIN_ROW_OFFSET                   4
#define FRAME_BUFFER_CONTROL_MAX_ROW_OFFSET                   6
#define FRAME_BUFFER_CONTROL_MIN_COL_OFFSET                   8
#define FRAME_BUFFER_CONTROL_MAX_COL_OFFSET                   10
#define FRAME_BUFFER_CONTROL_BUFFER_ID_OFFSET                 12
#define FRAME_BUFFER_CONTROL_DATA_OFFSET                      13
#define FRAME_BUFFER_CONTROL_FREE_MEMORY_OFFSET               (13+FBC_MAX_DATA_PATTERN_LEN)
#define FRAME_BUFFER_CONTROL_IMG_MAX_WIDTH_OFFSET             (15+FBC_MAX_DATA_PATTERN_LEN)
#define FRAME_BUFFER_CONTROL_IMG_MAX_HEIGHT_OFFSET            (16+FBC_MAX_DATA_PATTERN_LEN)
#define FRAME_BUFFER_CONTROL_IMG_NUM_IMGS_OFFSET              (17+FBC_MAX_DATA_PATTERN_LEN)
#define FRAME_BUFFER_CONTROL_IMG_DATA_OFFSET                  (18+FBC_MAX_DATA_PATTERN_LEN)


#define FRAME_BUFFER_CONTROL_LOAD                             0x01
#define FRAME_BUFFER_CONTROL_REMOVE                           0x02
#define FRAME_BUFFER_CONTROL_CLEAR                            0x04
#define FRAME_BUFFER_CONTROL_START                            0x08
#define FRAME_BUFFER_CONTROL_STOP                             0x10
#define FRAME_BUFFER_CONTROL_RUNNING                          0x80

#define EEPROM_FRAME_BUFFER_CONTROL_LENGTH                    8

#define FRAME_BUFFER_CONTROL_PERIOD_OFFSET                    0
#define FRAME_BUFFER_CONTROL_NUM_ROWS_OFFSET                  2
#define FRAME_BUFFER_CONTROL_NUM_PIXELS_OFFSET                4
#define FRAME_BUFFER_CONTROL_NUM_BUFFERS_OFFSET               6


#ifndef DEFAULT_FRAME_BUFFER_CONTROL_PERIOD
  #define DEFAULT_FRAME_BUFFER_CONTROL_PERIOD                 0x0004
#endif
#ifndef DEFAULT_FRAME_BUFFER_CONTROL_NUM_ROWS
  #define DEFAULT_FRAME_BUFFER_CONTROL_NUM_ROWS               0x0004
#endif
#ifndef DEFAULT_FRAME_BUFFER_CONTROL_NUM_PIXELS
  #define DEFAULT_FRAME_BUFFER_CONTROL_NUM_PIXELS             0x0030
#endif
#ifndef DEFAULT_FRAME_BUFFER_CONTROL_NUM_BUFFERS
  #define DEFAULT_FRAME_BUFFER_CONTROL_NUM_BUFFERS            0x0001
#endif

#define frame_buffer_control_eeprom_data(name,section_name,base_address,device_id) \
unsigned short int name##_eeprom_data[] __attribute__ ((section (section_name)))={DEFAULT_FRAME_BUFFER_CONTROL_PERIOD&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_PERIOD_OFFSET, \
                                                                                  (DEFAULT_FRAME_BUFFER_CONTROL_PERIOD>>8)&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_PERIOD_OFFSET+1, \
                                                                                  DEFAULT_FRAME_BUFFER_CONTROL_NUM_ROWS&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_NUM_ROWS_OFFSET, \
                                                                                  (DEFAULT_FRAME_BUFFER_CONTROL_NUM_ROWS>>8)&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_NUM_ROWS_OFFSET+1, \
                                                                                  DEFAULT_FRAME_BUFFER_CONTROL_NUM_PIXELS&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_NUM_PIXELS_OFFSET, \
                                                                                  (DEFAULT_FRAME_BUFFER_CONTROL_NUM_PIXELS>>8)&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_NUM_PIXELS_OFFSET+1, \
                                                                                  DEFAULT_FRAME_BUFFER_CONTROL_NUM_BUFFERS&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_NUM_BUFFERS_OFFSET, \
                                                                                  (DEFAULT_FRAME_BUFFER_CONTROL_NUM_BUFFERS>>8)&0x00FF,(device_id<<8)+base_address+FRAME_BUFFER_CONTROL_NUM_BUFFERS_OFFSET+1};

#endif

