#ifndef IMAGE_PATTERNS_H
#define IMAGE_PATTERNS_H

#include "patterns.h"
#include "frame_buffer_control.h"
#include "memory.h"

#ifndef IMG_MAX_NUM_IMAGES
  #error "Please, specify the maximum number of images with the IMG_MAX_NUM_IMAGES macro"
#endif

#ifndef IMG_MAX_IMAGE_WIDTH
  #error "Please, specify the maximum image width with the IMG_MAX_IMAGE_WIDTH macro"
#endif

#ifndef IMG_MAX_IMAGE_HEIGHT
  #error "Please, specify the maximum image height with the IMG_MAX_IMAGE_HEIGHT macro"
#endif

#define IMAGE_GROUP                  0x20

extern unsigned char img_pattern_data[IMG_MAX_NUM_IMAGES][IMG_MAX_IMAGE_WIDTH][IMG_MAX_IMAGE_HEIGHT][3];

void img_patterns_init(TMemory *memory,unsigned short int ram_base_address);

#pragma pack (push, 1)
typedef struct
{
  short int start_row;
  short int start_col;
  unsigned char buffer_id;
  unsigned char waveform_index;
  unsigned char motion_index;
}TIMGDisplayData;
#pragma pack (pop)

#define IMG_ID_OFFSET                   0x01
#define IMG_START_ROW_OFFSET            0
#define IMG_START_COL_OFFSET            2
#define IMG_BUFFER_ID_OFFSET            4
#define IMG_WF_INDEX_OFFSET             5
#define IMG_MTN_INDEX_OFFSET            6

void img_general(TLEDArea *area,TIMGDisplayData *pattern_data,unsigned char buffer_id,unsigned short int period,TFBControl *control);

#endif
