#include "buffer.h"

/* public functions */
unsigned char buffer_write_byte(TBuffer *buffer,unsigned char data)
{
  if(buffer->num_data<MAX_BUFFER_LENGTH)
  {
    buffer->data[buffer->wr_ptr++]=data;
    buffer->wr_ptr%=MAX_BUFFER_LENGTH;
    buffer->num_data++;
    return 1;
  }
  else return 0;
}

unsigned char buffer_read_byte(TBuffer *buffer,unsigned char *data)
{
  if(buffer->num_data>0)
  {
    *data=buffer->data[buffer->rd_ptr++];
    buffer->rd_ptr%=MAX_BUFFER_LENGTH;
    buffer->num_data--;
    return 1;
  }
  else
    return 0;
}

unsigned short int buffer_write(TBuffer *buffer,unsigned char *data,unsigned short int length)
{
  unsigned short int i,len;

  if(length>(MAX_BUFFER_LENGTH-buffer->num_data)) len=MAX_BUFFER_LENGTH-buffer->num_data;
  else len=length;
  for(i=0;i<len;i++)
  {
    buffer->data[buffer->wr_ptr++]=data[i];
    buffer->wr_ptr%=MAX_BUFFER_LENGTH;
    buffer->num_data++;
  }  

  return len;
}

unsigned short int buffer_read(TBuffer *buffer,unsigned char *data,unsigned short int length)
{
  unsigned short int i,len;

  if(length>buffer->num_data) len=buffer->num_data;
  else len=length;
  for(i=0;i<len;i++)
  {
    data[i]=buffer->data[buffer->rd_ptr++];
    buffer->rd_ptr%=MAX_BUFFER_LENGTH;
    buffer->num_data--;
  }
  
  return len;
}
